<?php
/*
  =====================================================
  Модуль "Редиректы" для DLE
  -----------------------------------------------------
  http://hostdev.pw/
  -----------------------------------------------------
  Copyright (c) 20015 Евгений Паникаровский
  =====================================================
  Данный код защищен авторскими правами
  =====================================================
  Файл: redirects.php
  -----------------------------------------------------
  Назначение: Управление редиректами
  =====================================================
 */

if (!defined('DATALIFEENGINE') OR !defined('LOGGED_IN')) {
	die("Hacking attempt!");
}

echoheader("Редиректы", "Модуль позволяет управлять редиректами");

$content = '';

$scriptname = $_SERVER['PHP_SELF'];
$row = $db->super_query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_admin_sections WHERE name = 'redirects' LIMIT 1");
if (is_null($row)) {
	if (isset($_POST['no_install'])) {
		ob_end_clean();
		header('Location: ');
		die();
	}
	if (isset($_POST['install'])) {
		$db->super_query("INSERT INTO `" . PREFIX . "_admin_sections` (`name`, `title`, `descr`, `icon`, `allow_groups`) VALUES ('redirects', 'Редиректы', 'Модуль позволяет управлять редиректами', 'redirects.png', '1');");
		$db->super_query("DROP TABLE IF EXISTS `" . PREFIX . "_redirects`;");
		$db->super_query("CREATE TABLE `" . PREFIX . "_redirects` (`id` SMALLINT(6) NOT NULL AUTO_INCREMENT,`old_url` VARCHAR(255) NOT NULL,`new_url` TINYTEXT NOT NULL,`active` TINYINT(1) NOT NULL DEFAULT '1',PRIMARY KEY (`id`),UNIQUE INDEX `old_url` (`old_url`))COLLATE='utf8_general_ci'ENGINE=MyISAM;");
		$db->super_query("INSERT INTO `" . PREFIX . "_redirects` (`old_url`, `new_url`, `active`) VALUES ('/old_url/', '/new_url/', 1);
");
		ob_end_clean();
		header("Location: {$scriptname}?mod=redirects");
		die();
	}
	?>
	<form method="post">
		<div class="box">
			<div class="box-header">
				<div class="title">Установка модуля "Редиректы"</div>
			</div>
			<div class="box-content">
				<div class="row box-section">
					<table width="100%">
						<tr>
							<td height="100" class="text-center settingstd">Вы уверены, что хотите установить модуль "Редиректы"?<br/><br/>
								<input class="btn btn-green" type="submit" value="Да" name="install"> &nbsp; <input type="submit" class="btn btn-red" value="Нет" name="no_install">
							</td>
						</tr>
					</table>
				</div>
			</div>
		</div>
	</form>
		<?php
	die();
}
?>
<style>
	body {
		cursor: default;
	}
	.actions {
		text-align: center;
	}
	.actions a {
		display: inline-block;
		width: 16px;
		margin: 0 5px;
		height: 16px;
		color:#369;
	}

	.actions a.del {
		color:#e00;
	}
	
	.toolbar-link .add {
		color: #0b0;
		line-height: 35px;
	}
</style>

<?php
if (isset($_GET['edit'])) {
	$id = intval($_GET['edit']);

	if ($id <= 0) {
		ob_end_clean();
		msg("error", 'Неверный идентификатор редиректа', 'Ошибка! Указан неверный идентификатор редиректа для редактирования', "{$scriptname}?mod=redirects");
	} else {
		$db->query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_redirects WHERE id = {$id} LIMIT 1");
		if ($db->num_rows() > 0) {
			if (isset($_POST['save_redirect'])) {
				$old_url = $db->safesql($_POST['old_url']);
				$new_url = $db->safesql($_POST['new_url']);
				if ($old_url == $new_url) {
					ob_end_clean();
					msg("error", 'Ошибка добавления редиректа', 'Новый адрес не может быть равен старому адресу', "javascript:history.go(-1)");
				}
				$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE id != {$id} and old_url = '{$old_url}' LIMIT 1");
				if ($db->num_rows() > 0) {
					ob_end_clean();
					msg("error", 'Редирект существует', 'Редирект с указанным адресом уже существует', "javascript:history.go(-1)");
				}
				$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE old_url = '{$new_url}' LIMIT 1");
				if ($db->num_rows() > 0) {
					ob_end_clean();
					msg("error", 'Ошибка добавления редиректа', 'Новый адрес редиректа конфликтует с уже существующим редиректом', "javascript:history.go(-1)");
				}
				$active = (isset($_POST['active'])) ? 1 : 0;
				$db->query("UPDATE " . PREFIX . "_redirects set `old_url` = '{$old_url}', `new_url` = '{$new_url}', `active` = {$active} WHERE id = {$id} LIMIT 1");
				ob_end_clean();
				msg("info", 'Редирект изменен', 'Редирект успешно изменен', "{$scriptname}?mod=redirects");
			}
			$row = $db->get_row();
			?>
			<form method="post" class="form-horizontal">
				<div class="box">
					<div class="box-header">
						<div class="title"><i class="icon-pencil"></i> Редактирование редиректа</div>
						<ul class="box-toolbar">
							<li class="toolbar-link">
								<a href="<?php echo $scriptname?>?mod=redirects">
									<i class="icon-list"></i> Список редиректов
								</a>
							</li>
						</ul>
					</div>
					<div class="box-content">
						<div class="row box-section">
							<div class="form-group">
								<label class="control-label col-lg-2">Старый адрес:</label>
								<div class="col-lg-10">
									<input type="text" name="old_url" size="55" value="<?php echo $row['old_url']; ?>" required="required"/>
								</div>
							</div>
							<div class="form-group">
								<label class="control-label col-lg-2">Новый адрес:</label>
								<div class="col-lg-10">
									<input type="text" name="new_url" size="55" value="<?php echo $row['new_url']; ?>" required="required"/>
								</div>
							</div>
							<div class="form-group">
								<label class="control-label col-lg-2"></label>
								<div class="col-lg-10">
									<input class="icheck" type="checkbox" name="active" id="active" value="1" <?php if ($row['active'] == 1) echo 'checked'; ?>><label for="active">Редирект активен</label>
								</div>
							</div>
							<div class="form-group">
								<label class="control-label col-lg-2"></label>
								<div class="col-lg-10">
									<input type="submit" value="Сохранить" name="save_redirect" class="btn btn-green">
								</div>
							</div>
						</div>
					</div>
				</div>
			</form>
			<?php
		} else {
			ob_end_clean();
			msg("error", 'Редирект не существует', 'Ошибка! Указанного редиректа не существует', "{$scriptname}?mod=redirects");
		}
	}
} elseif (isset($_GET['add'])) {
	if (isset($_POST['save_redirect'])) {
		$old_url = $db->safesql($_POST['old_url']);
		$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE old_url = '{$old_url}' LIMIT 1");
		if ($db->num_rows() > 0) {
			ob_end_clean();
			msg("error", 'Ошибка добавления редиректа', 'Редирект с указанным адресом уже существует', "javascript:history.go(-1)");
		}
		$db->query("SELECT * FROM " . PREFIX . "_redirects WHERE old_url = '{$new_url}' LIMIT 1");
		if ($db->num_rows() > 0) {
			ob_end_clean();
			msg("error", 'Ошибка добавления редиректа', 'Новый адрес редиректа конфликтует с уже существующим редиректом', "javascript:history.go(-1)");
		}
		$new_url = $db->safesql($_POST['new_url']);
		if ($old_url == $new_url) {
			ob_end_clean();
			msg("error", 'Ошибка добавления редиректа', 'Новый адрес не может быть равен старому адресу', "javascript:history.go(-1)");
		}
		$active = (isset($_POST['active'])) ? 1 : 0;
		$db->query("INSERT INTO " . PREFIX . "_redirects (`old_url`, `new_url`, `active`) VALUES ('{$old_url}', '{$new_url}', {$active} )");
		ob_end_clean();
		msg("info", 'Редирект добавлен', 'Редирект успешно добавлен', "{$scriptname}?mod=redirects");
	}
	?>
<form method="post" class="form-horizontal">
		<div class="box">
			<div class="box-header">
				<div class="title">Добавление редиректа</div>
				<ul class="box-toolbar">
					<li class="toolbar-link">
						<a href="<?php echo $scriptname?>?mod=redirects">
							<i class="icon-list"></i> Список редиректов
						</a>
					</li>
				</ul>
			</div>
			<div class="box-content">
				<div class="row box-section">
					<div class="form-group">
						<label class="control-label col-lg-2">Старый адрес:</label>
						<div class="col-lg-10">
							<input type="text" name="old_url" size="55" required/>
						</div>
					</div>
					<div class="form-group">
						<label class="control-label col-lg-2">Новый адрес:</label>
						<div class="col-lg-10">
							<input type="text" name="new_url" size="55" required/>
						</div>
					</div>
					<div class="form-group">
						<label class="control-label col-lg-2"></label>
						<div class="col-lg-10">
							<input class="icheck" type="checkbox" name="active" id="active" value="1" checked><label for="active">Редирект активен</label>
						</div>
					</div>
					<div class="form-group">
						<label class="control-label col-lg-2"></label>
						<div class="col-lg-10">
							<input type="submit" value="Сохранить" name="save_redirect" class="btn btn-green">
						</div>
					</div>
				</div>
			</div>
		</div>
	</form>
	<?php
} elseif ($_GET['delete']) {
	if (isset($_POST['nosubmit_del'])) {
		ob_end_clean();
		header("Location: {$scriptname}?mod=redirects");
		die();
	}
	if (isset($_POST['submit_del'])) {
		$id = intval($_GET['delete']);
		$db->query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_redirects WHERE id = {$id} LIMIT 1");
		if ($db->num_rows() > 0) {
			$db->query("DELETE FROM " . PREFIX . "_redirects WHERE id='{$id}'");
			ob_end_clean();
			msg("info", 'Внимание', 'Указанного редирект успешно удален', "{$scriptname}?mod=redirects");
		} else {
			ob_end_clean();
			msg("error", 'Ошибка удаления редиректа', 'Указанного редиректа не существует', "{$scriptname}?mod=redirects");
		}
	}
	?>
	<form method="post">
		<div class="box">
			<div class="box-header">
				<div class="title">Удаление редиректов</div>
			</div>
			<div class="box-content">
				<div class="row box-section">
					<table width="100%">
						<tr>
							<td height="100" class="text-center settingstd">Вы уверены, что хотите удалить выбранный редирект?<br/><br/>
								<input class="btn btn-green" type="submit" value="Да" name="submit_del"> &nbsp; <input type="submit" class="btn btn-red" value="Нет" name="nosubmit_del">
							</td>
						</tr>
					</table>
				</div>
			</div>
		</div></form>
	<?php
} else {
	$db->query("SELECT SQL_CALC_FOUND_ROWS * FROM " . PREFIX . "_redirects ORDER BY id ASC");
	?>
	<div class="box">
		<div class="box-header">
			<div class="title">Список редиректов</div>
			<ul class="box-toolbar">
				<li class="toolbar-link">
					<a href="<?php echo $scriptname?>?mod=redirects&add" class="add">
						<i class="icon-plus"></i> Добавить
					</a>
				</li>
			</ul>
		</div>
		<div class="box-content">
			<table class="table table-normal table-hover">
				<thead>
					<tr><th style="width:80px; text-align:center;">ID</th><th>Старый адрес</th><th>Новый адрес</th><th width="40">Статус</th><th width="50" align="center">Действия</th></tr>
				</thead>
				<?php
				if ($db->num_rows() > 0) {
					while ($row = $db->get_row()) {
						?>
						<tr>
							<td align="center"><?php echo $row['id'] ?></td>
							<td><?php echo $row['old_url'] ?></td>
							<td><?php echo $row['new_url'] ?></td>
							<td align="center"><?php if ($row['active'] == 1) {
				echo '<span class="status-success"><b><i class="icon-ok-sign"></i></b></span>';
			} else {
				echo '<span class="status-error"><b><i class="icon-exclamation-sign"></i></b></span>';
			} ?></td>
							<td class="actions">
								<a href="<?php echo $scriptname?>?mod=redirects&edit=<?php echo $row['id'] ?>"><i class="icon-pencil"></i></a>
								<a href="<?php echo $scriptname?>?mod=redirects&delete=<?php echo $row['id'] ?>" class="del"><i class="icon-remove"></i></a>
							</td>
						</tr>
						<?php
					}
				} else {
					?>
					<tr><td colspan="4" align="center">Редиректов нет</td></tr>
		<?php
	}
	?>
			</table>
		</div>
	</div>
	<?php
}

GzipOut();

echofooter();
